; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; CODE GNR AUTOMATIQUEMENT, NE PAS MODIFIER 
; MOINS D'AVOIR UNE RAISON TRS TRS VALABLE !!!
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Code gnr par : Dev-Module - V0.0.3
; Nom du projet : ToolBox Manager
; Nom du fichier : ToolBox Manager - ToolBoxManager.pb
; Version du fichier : 0.0.0
; Programmation :  vrifier
; Programm par : StarBootics
; Courriel : starbootics@cgocable.ca
; Date : 02-05-2015
; Mise  jour : 02-05-2015
; Cod pour : PureBasic 5.31
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule ToolBoxManager
  
  Declare Initialize()
  Declare CreateToolBoxManagerPreferences()
  Declare OpenToolBoxManagerPreferences()
  Declare CreateWindow()
  Declare EventManager()
  
EndDeclareModule

Module ToolBoxManager
  
  #ProgramName = "ToolBox Manager"
  #Version = "V2.0.1"
  
  Enumeration 
    
    #Run_Compile_Code
    #Run_Preferences
    #Run_Open_Source
    #Run_Load_Source
    #Run_Insert_ToolBoxFile
    
    ; ToolBox Manager Setting Window
    
    #SettingWindow
    
    #Tree_Setting_Path
    #Button_Setting_Add_Path
    #Button_Setting_Remove_Path
    #Button_Setting_Quit

    ; ToolBox Manager Inserting Window
    
    #InsertWindow
    
    #ListView_Insert_Files
    #Button_Insert_Insert
    #Button_Insert_Cancel
    
    ; ToolBox Manager Opening Window
    
    #OpenWindow
    
    #ListView_Open_Files
    #Button_Open_Open
    #Button_Open_Cancel
    
    #Shortcut_Escape
    
  EndEnumeration
  
  CompilerSelect #PB_Compiler_OS
      
    CompilerCase #PB_OS_Windows 
      #PathSep = "\"
      
    CompilerCase #PB_OS_Linux
      #PathSep = "/"
      
    CompilerCase #PB_OS_MacOS
      #PathSep = "/"
      
  CompilerEndSelect
  
  Structure Instance
    
    PrefFileName.s
    RunningMode.b
    
  EndStructure
  
  Global Instance.Instance
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Cration d'un fichier de Prfrences <<<<<
  
  Procedure CreateToolBoxManagerPreferences()
    
    If CreatePreferences(Instance\PrefFileName)
      
      Window::WritePrefs("SettingWindow", #SettingWindow) 
      Window::WritePrefs("InsertWindow", #InsertWindow)
      Window::WritePrefs("OpenWindow", #OpenWindow)
      ToolBox::WritePrefs("ToolBox")
      
      ClosePreferences()
      
    EndIf
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Ouverture d'un fichier de Prfrences <<<<<
  
  Procedure OpenToolBoxManagerPreferences()
    
    If OpenPreferences(Instance\PrefFileName)
      
      Window::ReadPrefs("SettingWindow", #SettingWindow)
      Window::ReadPrefs("InsertWindow", #InsertWindow)
      Window::ReadPrefs("OpenWindow", #OpenWindow)
      ToolBox::ReadPrefs("ToolBox")
      
      ClosePreferences()
      
    EndIf
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Rodimensionnement de la fentre et des gadgets <<<<<
  
  Procedure ReshapeWindow()
    
    If Instance\RunningMode = #Run_Preferences
      Window::GetCurrentSize(#SettingWindow)
      ResizeGadget(#Tree_Setting_Path, #PB_Ignore, #PB_Ignore, Window::Width(#SettingWindow) - 10, Window::Height(#SettingWindow) - 55)
      ButtonGroup::Move(#Button_Setting_Add_Path, #Button_Setting_Quit, Window::Width(#SettingWindow) - 180*3 - 15, Window::Height(#SettingWindow) - 40);, 160, 30)
    EndIf
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Routine de fermeture du programme <<<<<
  
  Procedure ShutDown(ExitCode.b)
    
    Select Instance\RunningMode
        
      Case #Run_Preferences
        Window::GetCurrentPositionSize(#SettingWindow)
        CloseWindow(#SettingWindow)
        
      Case #Run_Insert_ToolBoxFile
        Window::GetCurrentPositionSize(#InsertWindow)
        CloseWindow(#InsertWindow)
        
      Case #Run_Open_Source
        Window::GetCurrentPositionSize(#OpenWindow)
        CloseWindow(#OpenWindow)
        
    EndSelect
    
    CreateToolBoxManagerPreferences()
    
    Instance\PrefFileName = ""
    Instance\RunningMode = 0

    Window::Reset(-1)
    ToolBox::Reset()
    Language::Reset()

    End ExitCode
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Routine d'initialisation du programme <<<<<
  
  Procedure Initialize()
    
    ; Traitement des Paramtres de lancement du programme
    
    ParamMax.l = CountProgramParameters()
    
    If ParamMax > 0
      
      Select ProgramParameter(0)
          
        Case "PREFS"
          Instance\RunningMode = #Run_Preferences
          
        Case "OPEN"
          Instance\RunningMode =  #Run_Open_Source
          
        Case "COMPILE"
          Instance\RunningMode = #Run_Compile_Code
          ToolBox::SetEditorOutputFile(ProgramParameter(1))
          
        Case "LOAD"
          Instance\RunningMode = #Run_Load_Source
          ToolBox::SetCurrentFile(ProgramParameter(1))
          Position.s = ProgramParameter(2)
          ToolBox::SetCurrentLine(Val(StringField(Position, 1, "x")))
          ToolBox::SetCurrentRow(Val(StringField(Position, 2, "x")) - 1)

        Case "INSERT"
          Instance\RunningMode = #Run_Insert_ToolBoxFile
          ToolBox::SetCurrentFile(ProgramParameter(1))
          Position.s = ProgramParameter(2)
          ToolBox::SetCurrentLine(Val(StringField(Position, 1, "x")))
          ToolBox::SetCurrentRow(Val(StringField(Position, 2, "x")) - 1)
          
        Default 
          End
          
      EndSelect
      
    EndIf
    
    CompilerSelect #PB_Compiler_OS
        
      CompilerCase #PB_OS_Windows 
        UserPath.s = GetEnvironmentVariable("APPDATA") + #PathSep + "Purebasic" + #PathSep
        
        If Left(UserPath, 2) <> "C:"
          UserPath = "C:" + #PathSep + UserPath
        EndIf
        
      CompilerCase #PB_OS_Linux
        UserPath.s = GetHomeDirectory() + ".purebasic" + #PathSep
        
    CompilerEndSelect
    
    BuiltPathDirectory::DoIt(UserPath)

    Instance\PrefFileName = UserPath + "toolbox_manager.prefs"
    
    SetCurrentDirectory(GetPathPart(ProgramFilename()))
    
    Window::Initialize(#SettingWindow, 50, 50, 550, 340)
    Window::Initialize(#InsertWindow, 50, 50, 315, 400, #False)
    Window::Initialize(#OpenWindow, 50, 50, 315, 400, #False)
    Language::Initialize("", GetPathPart(ProgramFilename()) + "language" + #PathSep)
    ToolBox::Initialize(#ProgramName)
    
    If FileSize(Instance\PrefFileName) = -1
      CreateToolBoxManagerPreferences()
    Else
      OpenToolBoxManagerPreferences()
    EndIf

    ToolBox::ScanDirectories()
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Cration de la fentre <<<<<
  
  Procedure CreateWindow()
    
    Select Instance\RunningMode
        
      Case #Run_Preferences
        
        Window::SanityCheck(#SettingWindow)
        
        If Window::Open(#SettingWindow, #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget | #PB_Window_SizeGadget)
          
          WindowBounds(#SettingWindow, 550, 340, #PB_Ignore, #PB_Ignore) 
          Window::GetCurrentPositionSize(#SettingWindow)
          Window::Reshape(#SettingWindow)
          
          TreeGadget(#Tree_Setting_Path, 5, 5, Window::Width(#SettingWindow) - 10, Window::Height(#SettingWindow) - 55, #PB_Tree_CheckBoxes)    
          ButtonGroup::Horizontal(#Button_Setting_Add_Path, #Button_Setting_Quit, Window::Width(#SettingWindow) - 180*3 - 15, Window::Height(#SettingWindow) - 40, 180, 30, 5)
          
          SetWindowTitle(#SettingWindow, #ProgramName + " " + #Version)
          
          SetGadgetText(#Button_Setting_Add_Path, Language::Message("Add Path"))
          SetGadgetText(#Button_Setting_Remove_Path, Language::Message("Remove Path"))
          SetGadgetText(#Button_Setting_Quit, Language::Message("Quit"))
          
          ToolBox::Paths_To_GUI(#Tree_Setting_Path)
          
        EndIf
        
      Case #Run_Insert_ToolBoxFile
        
        Window::SanityCheck(#InsertWindow)
        
        If Window::Open(#InsertWindow)
          
          ListViewGadget(#ListView_Insert_Files, 5, 5, Window::Width(#InsertWindow) - 10, Window::Height(#InsertWindow) - 45, #PB_ListView_ClickSelect) 
          ButtonGroup::Horizontal(#Button_Insert_Insert, #Button_Insert_Cancel, Window::Width(#InsertWindow) - 300, Window::Height(#InsertWindow) - 35, 145, 30)
          
          SetWindowTitle(#InsertWindow, #ProgramName + " " + #Version)
          SetGadgetText(#Button_Insert_Insert, Language::Message("Insert"))
          SetGadgetText(#Button_Insert_Cancel, Language::Message("Cancel"))
          
          ToolBox::Files_To_GUI(#ListView_Insert_Files)
          
          AddKeyboardShortcut(#InsertWindow, #PB_Shortcut_Escape, #Shortcut_Escape)
          
        EndIf
        
      Case #Run_Open_Source
        
        Window::SanityCheck(#OpenWindow)
        
        If Window::Open(#OpenWindow)
          
          ListViewGadget(#ListView_Open_Files, 5, 5, Window::Width(#OpenWindow) - 10, Window::Height(#OpenWindow) - 45, #PB_ListView_ClickSelect) 
          ButtonGroup::Horizontal(#Button_Open_Open, #Button_Open_Cancel, Window::Width(#OpenWindow) - 300, Window::Height(#OpenWindow) - 35, 145, 30)
          
          SetWindowTitle(#OpenWindow, #ProgramName + " " + #Version)
          SetGadgetText(#Button_Open_Open, Language::Message("Open"))
          SetGadgetText(#Button_Open_Cancel, Language::Message("Cancel"))
          
          ToolBox::Files_To_GUI(#ListView_Open_Files)
          
          AddKeyboardShortcut(#OpenWindow, #PB_Shortcut_Escape, #Shortcut_Escape)
          
        EndIf
        
    EndSelect
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Gestion des vnements <<<<<
  
  Procedure EventManager()
    
    Select Instance\RunningMode
        
      Case #Run_Preferences, #Run_Insert_ToolBoxFile, #Run_Open_Source
        
        Repeat
          
          Select WaitWindowEvent()
              
            Case #PB_Event_SizeWindow
              ReshapeWindow()
              
            Case #PB_Event_CloseWindow
              
              Select EventWindow()
                  
                Case #SettingWindow, #InsertWindow, #OpenWindow
                  Shutdown(-1)
                  
              EndSelect
              
            Case #PB_Event_Menu
              
              Select EventMenu()
                  
                Case #Shortcut_Escape
                  Shutdown(-1)
                  
              EndSelect
              
            Case #PB_Event_Gadget
              
              Select EventGadget()
                  
                Case #Button_Setting_Add_Path
                  ToolBox::AddNewPath()
                  ToolBox::Paths_To_GUI(#Tree_Setting_Path)
                  
                Case #Button_Setting_Remove_Path
                  ToolBox::DeletePath(#Tree_Setting_Path)
                  ToolBox::Paths_To_GUI(#Tree_Setting_Path)
                  
                Case #Button_Setting_Quit
                  ToolBox::GUI_To_Paths(#Tree_Setting_Path)
                  Shutdown(0)
                  
                Case #Button_Insert_Insert
                  ToolBox::GUI_To_Files(#ListView_Insert_Files)
                  Shutdown(0)
                  
                Case #Button_Insert_Cancel, #Button_Open_Cancel
                  Shutdown(-1)
                  
                Case #Button_Open_Open
                  ToolBox::Open_To_IDE(#ListView_Open_Files)
                  Shutdown(0)
                  
              EndSelect
              
          EndSelect
          
        ForEver
        
      Case #Run_Compile_Code
        ToolBox::Replace_ToolBoxFile_By_IncludeFile(#ProgramName)
        Shutdown(0)
        
      Case #Run_Load_Source
        ToolBox::Load_ToolBoxFile_To_IDE(#ProgramName)
        Shutdown(0)
        
    EndSelect 
    
  EndProcedure
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code gnr en : 00.001 secondes (91000.00 lignes/seconde) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.42 LTS (Linux - x64)
; Folding = ---
; EnableUnicode
; EnableXP
; CompileSourceDirectory